//
// Copyright(C) 2007-2014 Samuel Villarreal
// Copyright(C) 2015 Night Dive Studios, Inc.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

#pragma once

#if EMULATE_UNIFORM_BUFFERS

#define IMPLEMENT_UNIFORM_BUFFER_RENDERVIEW()   \
    uniform mat4    uProjectionMatrix;  \
    uniform mat4    uInverseProjectionMatrix;   \
    uniform mat4    uPrevProjection;  \
    uniform mat4    uModelViewMatrix;   \
    uniform mat4    uInverseModelViewMatrix;    \
    uniform mat4    uPrevModelView; \
    uniform mat4    uRotationMatrix;    \
    uniform mat4    uInverseRotationMatrix; \
    uniform mat4    uTransposedRotationMatrix;  \
    uniform mat4    uClipMatrix;    \
    uniform mat4    uInverseClipMatrix; \
    uniform mat4    uPrevClipMatrix;    \
    uniform mat4    uNormalMatrix;  \
    uniform vec3    uViewOrigin;    \
    uniform float   uViewWidth; \
    uniform float   uViewHeight;    \
    uniform float   uZNear; \
    uniform float   uZFar;  \
    uniform vec2    uInvFocalCoords;    \
    uniform vec4    uFrustumCorners[4]
#else

#define IMPLEMENT_UNIFORM_BUFFER_RENDERVIEW()   \
uniform_buffer(RenderView, 0)  \
{   \
    mat4        uProjectionMatrix;  \
    mat4        uModelViewMatrix;   \
    mat4        uInverseProjectionMatrix;   \
    mat4        uPrevProjection;  \
    mat4        uInverseModelViewMatrix;    \
    mat4        uPrevModelView; \
    mat4        uRotationMatrix;    \
    mat4        uInverseRotationMatrix; \
    mat4        uTransposedRotationMatrix;  \
    mat4        uClipMatrix;    \
    mat4        uInverseClipMatrix; \
    mat4        uPrevClipMatrix;    \
    mat4        uNormalMatrix;  \
    vec3        uViewOrigin;    \
    float       uViewWidth; \
    float       uViewHeight;    \
    float       uZNear; \
    float       uZFar;  \
    vec2        uInvFocalCoords;    \
    vec4        uFrustumCorners[4]; \
}
 
#endif // EMULATE_UNIFORM_BUFFERS
